#ifndef COMMON_STRUCT_H
#define COMMON_STRUCT_H

struct Head {
	int type;
	int lenth;
};

enum typeInfo
{
    //年产量 请求/响应
	BIGSCREEN_ANNUAL_REQ,
	BIGSCREEN_ANNUAL_RES,

    //月产量 请求/响应
	BIGSCREEN_MONTH_REQ,
	BIGSCREEN_MONTH_RES,

    //原料 请求/响应
	BIGSCREEN_MATERIAL_REQ,
	BIGSCREEN_MATERIAL_RES,


    //总订单 请求/响应
	BIGSCREEN_ORDER_REQ,
	BIGSCREEN_ORDER_RES,


    //当日订单 请求/响应
	BIGSCREEN_DAILY_REQ,
	BIGSCREEN_DAILY_RES,


    //环境  请求/响应
	BIGSCREEN_ENVIRONMENT_REQ,
	BIGSCREEN_ENVIRONMENT_RES,


    //产品  请求/响应
	BIGSCREEN_PRODUCT_REQ,
	BIGSCREEN_PRODUCT_RES,

    //质量 请求/响应
	BIGSCREEN_QUALITY_REQ,
	BIGSCREEN_QUALITY_RES
};


//请求年度汇总数据 结构体
struct BS_annualReq
{
	Head head;
    int year;				//年份
	BS_annualReq() {
		head.type = BIGSCREEN_ANNUAL_REQ;
		head.lenth = sizeof(BS_annualReq);
	}
};

//产品信息存储
struct BS_annual
{
    char prod_type[32];     // 产品类型
    int prod_num;			//该产品总数量
    int prod_orders;		//该产品总订单
    int prod_money;			//该产品总金额

};

//年度总数据响应
struct BS_annualRes
{
	Head head;
	int count;
	BS_annual dataResNum[0];
	BS_annualRes() {
		head.type = BIGSCREEN_ANNUAL_RES;
        head.lenth = sizeof(BS_annualRes);
	}
};

struct BS_monthReq
{
	Head head;
	int year;
	BS_monthReq() {
		head.type = BIGSCREEN_MONTH_REQ;
		head.lenth = sizeof(BS_monthReq);
	}
};

struct BS_month
{
    char prod_type[32];     // 产品类型
    int month;                //月份
    int num;                 //数量
};

struct BS_monthRes
{
	Head head;
	int count;
	BS_monthRes() {
		head.type = BIGSCREEN_MONTH_RES;
	}
	BS_month dataResNum[0];
};

//原料信息
struct BS_materialReq
{
	Head head;
	BS_materialReq() {
		head.type = BIGSCREEN_MATERIAL_REQ;
		head.lenth = sizeof(BS_materialReq);
	}
};


struct BS_material
{
    char material_type[32];     //类型
    int maxnum;                 //最大存储数量
    int storenum;               //数量
    char status[32];            //状态״̬
};

struct BS_materialRes
{
	Head head;
	int count;
	BS_material dataResNum[];
	BS_materialRes() {
		head.type = BIGSCREEN_MATERIAL_RES;
	}
};

struct BS_orderReq {
	Head head;
	BS_orderReq() {
		head.type = BIGSCREEN_ORDER_REQ;
		head.lenth = sizeof(BS_orderReq);
	}
};

struct BS_order
{
	char order_number[50];
	char product_type[50];
	char start_date[50];
    char end_date[50];
	int plan_quantity;
	int production_quantity;
	char order_status[50];
};

struct BS_orderRes
{
	Head head;
	BS_orderRes() {
		head.type = BIGSCREEN_ORDER_RES;
		head.lenth = sizeof(BS_orderRes);
	}
	int count;
	BS_order dataResNum[0];
};

//每日信息
struct BS_dailyReq {
	Head head;
	BS_dailyReq() {
		head.type = BIGSCREEN_DAILY_REQ;
		head.lenth = sizeof(BS_dailyReq);
	}
};

struct BS_daily
{
	char process[32];
	int num;
};

struct BS_dailyRes
{
	Head head;
	BS_dailyRes() {
		head.type = BIGSCREEN_DAILY_RES;
		head.lenth = sizeof(BS_dailyRes);
	}
	int count;
	BS_daily dataResNum[0];
};

// 环境信息
struct BS_environment
{
    char warning_area[50];   // 工厂
       char warning_level[50];  // 警报级别
       double temperature;      // 温度
       double humidity;         // 湿度
       double particle;         // 粒子浓度
       char lng[50];            // 经度
       char lat[50];            // 纬度
};

struct BS_envirReq {
	Head head;
	BS_envirReq() {
		head.type = BIGSCREEN_ENVIRONMENT_REQ;
		head.lenth = sizeof(BS_envirReq);
	}
	BS_environment envir;
};

struct BS_environmentRes {
	Head head;
	BS_environmentRes() {
		head.type = BIGSCREEN_ENVIRONMENT_RES;
		head.lenth = sizeof(BS_environmentRes);
	}
	BS_environment envir;
};

struct BS_environmentReq
{
    Head head;
    BS_environmentReq() {
        head.type = 100;
        head.lenth = sizeof(BS_environmentReq);
    }
    char warning_area[50];   // 工厂
        char warning_level[50];  // 警报级别
        double temperature;      // 温度
        double humidity;         // 湿度
        double particle;         // 粒子浓度
        char lng[50];            // 经度
        char lat[50];            // 纬度
};

// 产品信息
struct BS_product
{

	char product_id[50];
	char status[50];
	char product_time[50];
};

struct BS_productReq
{
	Head head;
	BS_productReq() {
		head.type = BIGSCREEN_PRODUCT_REQ;
		head.lenth = sizeof(BS_productReq);
	}
	BS_product product;
};

struct BS_productRes
{
	Head head;
	BS_productRes() {
		head.type = BIGSCREEN_PRODUCT_RES;
		head.lenth = sizeof(BS_productRes);
	}
	BS_product product;
};


//质量信息
struct BS_qualityReq
{
	Head head;
	BS_qualityReq() {
		head.type = BIGSCREEN_QUALITY_REQ;
		head.lenth = sizeof(BS_qualityReq);
	}
};

struct BS_quality
{
	char quality_type[50];
	int num;
};

struct BS_qualityRes
{
	Head head;
	BS_qualityRes() {
		head.type = BIGSCREEN_QUALITY_RES;
	}
	int count;
	BS_quality dataResNum[];
};










#endif // COMMON_STRUCT_H
