#include "mainwindow.h"
#include "ui_mainwindow.h"
#include<QDebug>

 int BigScreen_ProductionTarget=0;
 int BigScreen_realgoal=0;
 int    BigScreen_TotalPlannedQuantity=0;
 int BigScreen_ActualTotalQuantity=100;


MainWindow::MainWindow(QWidget *parent):
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    modifyChuanganqi();
    modifyQcharts();
    setupTimer();
    modifyProgress();
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(QHeaderView::Stretch);
    ui->tableWidget_2->horizontalHeader()->setSectionResizeMode(QHeaderView::Stretch);

    //客户端连接
    m_client=new ClientTcpSocket(this);

    connect(m_client->Csocket(),&QTcpSocket::readyRead,this,&MainWindow::myRead);

    BS_annualReq m_annualReq;
    m_annualReq.year=2024;
}


MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::myRead()
{
    QByteArray buffer=m_client->Csocket()->readAll();
    int type=((Head*)buffer.data())->type;

    if(type==BIGSCREEN_ANNUAL_RES){
        BS_annualRes * m_annuaRes=(BS_annualRes*)buffer.data();
        int num=( m_annuaRes->head.lenth-sizeof(BS_annualRes))/sizeof(BS_annual);
        BigScreen_ProductionTarget=0;
        for(int i=0;i<num;++i){
            BigScreen_ProductionTarget+=m_annuaRes->dataResNum[i].prod_num;
        }
    }else if(type==BIGSCREEN_MONTH_RES){
        BS_monthRes *m_monthRes=(BS_monthRes*)buffer.data();
        int num=( m_monthRes->head.lenth-sizeof(BS_monthRes))/sizeof(BS_month);
      BigScreen_ActualTotalQuantity=0;
      for(int i=0;i<num;++i){
          BigScreen_ActualTotalQuantity+=m_monthRes->dataResNum[i].num;
    }
    }else if(type==BIGSCREEN_MATERIAL_RES){
        BS_materialRes *m_materialRes=(BS_materialRes*)buffer.data();
        int num=( m_materialRes->head.lenth-sizeof(m_materialRes))/sizeof(BS_material);
        BigScreen_TotalPlannedQuantity=0;
        for(int i=0;i<num;++i){
            BigScreen_ActualTotalQuantity+=m_materialRes->dataResNum[i].storenum;
            BigScreen_ActualTotalQuantity+=m_materialRes->dataResNum[i].maxnum;
      }
    }
}



void MainWindow::modifyChuanganqi()
{
//   BigScreen_productplan=qrand() % (9999 - 0 + 1) + 4000;
//   BigScreen_realplan=qrand() % (9999 - 0 + 1) + 3000;
    int  BigScreen_temp=qrand() % (100 - 0 + 1) + 30;
     int  BigScreen_temp2=qrand() % (100 - 0 + 1) + 40;


    ui->lcdNumber->setSegmentStyle(QLCDNumber::Flat);
    ui->lcdNumber_2->setSegmentStyle(QLCDNumber::Flat);
    ui->lcdNumber->display( BigScreen_temp); //温度
    ui->lcdNumber_2->display(BigScreen_temp2);  //湿度

    ui->lcdNumber_7->setSegmentStyle(QLCDNumber::Flat);
    ui->lcdNumber_7->display(BigScreen_ProductionTarget); //生产目标

    ui->lcdNumber_6->setSegmentStyle(QLCDNumber::Flat);
    ui->lcdNumber_6->display(BigScreen_realgoal);  //实际产量

}



void MainWindow::setupTimer()
{
    timer = new QTimer(this);
       connect(timer, &QTimer::timeout, this, &MainWindow::modifyChuanganqi);
       connect(timer, &QTimer::timeout, this, &MainWindow::modifyQcharts);
       timer->start(3000);
}

void MainWindow::modifyQcharts() //原料

{

          chart= new QChart();
          barSet1 = new QBarSet("预计总量");
          barSet2 = new QBarSet("实际总量");
          barSet1->append( BigScreen_TotalPlannedQuantity); //预计总量
          barSet2->append( BigScreen_ActualTotalQuantity); //实际总量
          barSet1->setColor(QColor(0,255,0));
          barSet2->setColor(QColor(255,0,1));

     QBarSeries *series = new QBarSeries();
     series->append(barSet1);
     series->append(barSet2);
     series->setBarWidth(0.5);  //条形宽度
     series->setVisible(true);
     series->setLabelsVisible(true);
     series->setLabelsPosition(QBarSeries::LabelsCenter);

//     QValueAxis *axisY = new QValueAxis();  //设置坐标轴
//     axisY->setRange(0,4000);
//     chart->addAxis(axisY,Qt::AlignLeft);

     chart->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
     chart->addSeries(series);
     chart->setBackgroundBrush(QBrush(QColor(4, 6, 51))); // 设置背景颜色
     chart->setAnimationOptions(QChart::AllAnimations); // 启用所有动画
     chart->legend()->setLabelBrush(QBrush(QColor(255, 255, 255))); //图样颜色

     QChartView *chartView = new QChartView(chart);
     chartView->setRenderHint(QPainter::Antialiasing);
     chartView->setParent(ui->widget_8);
     chartView->resize(ui->widget_8->size());
}

void MainWindow::modifyProgress()
{
    double res=static_cast<double>(BigScreen_realgoal) / BigScreen_ProductionTarget;;
    int percentage = static_cast<int>(res * 100 + 0.5);
    ui->progressBar_3->setValue(percentage); //日进度
    ui->progressBar_4->setValue(40); //月生产进度
    ui->progressBar_5->setValue(50); //设备一 正常状态占比
    ui->progressBar_6->setValue(60);//设备二 正常状态占比
    ui->progressBar_7->setValue(70);//设备三 正常状态占比
}




